//
// Created by martin on 25.03.22.
//

#ifndef ANIMTESTBED_ANIMGRAPH_H
#define ANIMTESTBED_ANIMGRAPH_H

#include "AnimNode.h"
#include "AnimGraphData.h"

//
// AnimGraph (Runtime)
//
struct AnimGraph {
  ~AnimGraph() {}

  bool Init(AnimGraphContext& context) {
    return m_root_node->Init(context);
  }
  void UpdateTime(float dt) {
    m_time_last = m_time_now;
    m_time_now = m_time_now + dt;
    m_root_node->UpdateTime(m_time_last, m_time_now);
  }
  void Evaluate(AnimGraphContext& context) {

  }

  AnimNode* m_root_node = nullptr;

  float m_time_now = 0.f;
  float m_time_last = 0.f;

  Vec3 m_root_bone_translation = {};
  Quat m_root_bone_rotation = {};
};

#endif  // ANIMTESTBED_ANIMGRAPH_H
